## target distribution ##
f=function(x){
  if(all(x<=10) & all(x>=-10)) {
    return(exp(-x[1]^2/2)*exp(-((1/sin(x[2]))^5-x[1])^2/2)) 
  } else {return(0);}
}

## true density with normalizing constant ##
g=function(x){exp(-(1/sin(x))^10/4)/4.488231}
g2=function(x,y){
  if(all(c(x,y)>=-10) & all(c(x,y)<=10)){
    ff=exp(-x^2/2)*exp(-((1/sin(y))^5-x)^2/2)
  } else ff=0;
  return(ff)
}
x.seq=seq(-10,10,0.001)
pi.x=NULL
for(i in 1:length(x.seq)){
  myt=function(y){return(g2(x.seq[i],y))}
  pi.x[i]=integrate(myt,-10,10)$value
}
plot(x.seq,pi.x/7.955136,type="l")

# require package "msm"
library("msm")

## ordinary MCMC ##
N=100000
x=matrix(0,N+1,2);
u=runif(N,0,1)
x[1,]=c(0,2);
for (i in 1:N){
  temp.x=NULL
  temp.x[1]=rtnorm(1,x[i,1],0.3,lower=-10,upper=10)
  temp.x[2]=rtnorm(1,x[i,2],0.3,lower=-10,upper=10)
  if (u[i]<f(temp.x)*dtnorm(x[i,1],temp.x[1],0.3,lower=-10,upper=10)*dtnorm(x[i,2],temp.x[2],0.3,lower=-10,upper=10)/f(x[i,])/dtnorm(temp.x[1],x[i,1],0.3,lower=-10,upper=10)/dtnorm(temp.x[2],x[i,2],0.3,lower=-10,upper=10)) {x[i+1,]=temp.x} else {x[i+1,]=x[i,]}
}
par(mfrow=c(2,1))
hist(x[,1],xlim=c(-10,10),freq=F,breaks=50,main="",ylim=c(0,0.65),xlab="x",ylab=expression(paste(pi,"(x)")))
lines(x.seq,pi.x/7.955136,type="l",lwd=2)
hist(x[,2],xlim=c(-10,10),freq=F,breaks=20,main="",ylim=c(0,1),xlab="y",ylab=expression(paste(pi,"(y)")))
curve(g,-10,10,ylim=c(0,0.2),xlab="y",add=T,lwd=2,n=10000)


## SMSS algorithms ##
multi=function(x,s)
{
  length(which(colSums(t(s)-x)==0))
}

## SMS-MWG ## 
N=100000;K=5;
x=matrix(0,N+1,2);
u=runif(2*N,0,1);
x[1,]=c(0,2);S=matrix(rep(x[1,],K),K,2,byrow=T);
for(i in 1:N){
  id=sample(1:K,1);
  tmp=S;
  tmp[id,1]=rtnorm(1,S[id,1],0.3,lower=-10,upper=10)
  tmp[id,2]=rtnorm(1,S[id,2],0.3,lower=-10,upper=10)
  if(u[i]<=multi(x[i,],tmp)*multi(tmp[id,],tmp)*dtnorm(S[id,1],tmp[id,1],0.3,lower=-10,upper=10)*dtnorm(S[id,2],tmp[id,2],0.3,lower=-10,upper=10)/multi(x[i,],S)/multi(S[id,],S)/dtnorm(tmp[id,1],S[id,1],0.3,lower=-10,upper=10)/dtnorm(tmp[id,2],S[id,2],0.3,lower=-10,upper=10)) S=tmp;
  prop=apply(S,1,f);
  x.id=sample(1:K,1,prob=prop);
  x[i+1,]=S[x.id,];
}
par(mfrow=c(2,1))
hist(x[,1],xlim=c(-10,10),freq=F,breaks=100,main="",ylim=c(0,0.5),xlab="x",ylab=expression(paste(pi,"(x)")))
lines(x.seq,pi.x/7.955136,type="l",lwd=2)
hist(x[,2],xlim=c(-10,10),freq=F,breaks=200,main="",ylim=c(0,0.25),xlab="y",ylab=expression(paste(pi,"(y)")))
g=function(x){exp(-(1/sin(x))^10/4)/4.488231}
curve(g,-10,10,ylim=c(0,0.2),xlab="y",add=T,lwd=2,n=10000)


## SMS-CBMC ##
N=100000;K=5;
x=matrix(0,N+1,2);
u=runif(N,0,1);
x[1,]=c(0,2);S=matrix(rep(x[1,],K),K,2,byrow=T);
count=0
for(i in 1:N){
  id=sample(1:K,1);
  tmp=S;
  tmp[id,1]=rtnorm(1,S[id,1],0.3,lower=-10,upper=10)
  tmp[id,2]=rtnorm(1,S[id,2],0.3,lower=-10,upper=10)
  if(u[i]<=sum(apply(tmp,1,f))*multi(tmp[id,],tmp)*dtnorm(S[id,1],tmp[id,1],0.3,lower=-10,upper=10)*dtnorm(S[id,2],tmp[id,2],0.3,lower=-10,upper=10)/sum(apply(S,1,f))/multi(S[id,],S)/dtnorm(tmp[id,1],S[id,1],0.3,lower=-10,upper=10)/dtnorm(tmp[id,2],S[id,2],0.3,lower=-10,upper=10)) {
    S=tmp; 
    prop=apply(S,1,f);
    x.id=sample(1:K,1,prob=prop);
    x[i+1,]=S[x.id,];
    count=count+1;
  } else x[i+1,]=x[i,];
}
par(mfrow=c(2,1))
hist(x[,1],xlim=c(-10,10),freq=F,breaks=100,main="",ylim=c(0,0.5),xlab="x",ylab=expression(paste(pi,"(x)")))
lines(x.seq,pi.x/7.955136,type="l",lwd=2)
hist(x[,2],xlim=c(-10,10),freq=F,breaks=200,main="",ylim=c(0,0.2),xlab="y",ylab=expression(paste(pi,"(y)")))
g=function(x){exp(-(1/sin(x))^10/4)/4.488231}
curve(g,-10,10,ylim=c(0,0.2),xlab="y",add=T,lwd=2,n=10000)


## R-SMS-CBMC ## 
N=100000;K=5;
x=matrix(0,N+1,2);
u=runif(N,0,1);
x[1,]=c(0,2);S=matrix(rep(x[1,],K),K,2,byrow=T);
for(i in 1:N){
  id=sample(1:K,1);
  tmp=S;
  tmp[id,1]=rtnorm(1,S[id,1],0.5,lower=-10,upper=10)
  tmp[id,2]=rtnorm(1,S[id,2],0.5,lower=-10,upper=10)
  if(u[i]<=sum(apply(tmp,1,f))*multi(tmp[id,],tmp)*dtnorm(S[id,1],tmp[id,1],0.5,lower=-10,upper=10)*dtnorm(S[id,2],tmp[id,2],0.5,lower=-10,upper=10)/sum(apply(S,1,f))/multi(S[id,],S)/dtnorm(tmp[id,1],S[id,1],0.5,lower=-10,upper=10)/dtnorm(tmp[id,2],S[id,2],0.5,lower=-10,upper=10)) S=tmp; 
  prop=apply(S,1,f);
  x.id=sample(1:K,1,prob=prop);
  x[i+1,]=S[x.id,];
}
par(mfrow=c(2,1))
hist(x[,1],xlim=c(-10,10),freq=F,breaks=100,main="",ylim=c(0,0.5),xlab="x",ylab=expression(paste(pi,"(x)")))
lines(x.seq,pi.x/7.955136,type="l",lwd=2)
hist(x[,2],xlim=c(-10,10),freq=F,breaks=200,main="",ylim=c(0,0.2),xlab="y",ylab=expression(paste(pi,"(y)")))
g=function(x){exp(-(1/sin(x))^10/4)/4.488231}
curve(g,-10,10,ylim=c(0,0.2),xlab="y",add=T,lwd=2,n=10000)


### Comparison with MSS and GMSS ### 

## R-SMS-CBMC ##
N=1e5;K=3;
x=matrix(0,N+1,2);
u=runif(N,0,1);
x[1,]=c(0,2);S=matrix(rep(x[1,],K),K,2,byrow=T);
for(i in 1:N){
  id=sample(1:K,1);
  tmp=S;
  tmp[id,1]=rtnorm(1,S[id,1],0.5,lower=-10,upper=10)
  tmp[id,2]=rtnorm(1,S[id,2],0.5,lower=-10,upper=10)
  if(u[i]<=sum(apply(tmp,1,f))*multi(tmp[id,],tmp)*dtnorm(S[id,1],tmp[id,1],0.5,lower=-10,upper=10)*dtnorm(S[id,2],tmp[id,2],0.5,lower=-10,upper=10)/sum(apply(S,1,f))/multi(S[id,],S)/dtnorm(tmp[id,1],S[id,1],0.5,lower=-10,upper=10)/dtnorm(tmp[id,2],S[id,2],0.5,lower=-10,upper=10)) S=tmp; 
  prop=apply(S,1,f);
  x.id=sample(1:K,1,prob=prop);
  x[i+1,]=S[x.id,];
}
endpoint=seq(-10,10,0.1)
hist(x[,2],xlim=c(-10,10),freq=F,breaks=endpoint,main="",ylim=c(0,0.25),xlab="Y")
g=function(x){exp(-(1/sin(x))^10/4)/4.488231}
curve(g,-10,10,ylim=c(0,0.25),xlab="y",add=T,lwd=2,n=10000)

## MSS ##
target=function(x,y){
  if(x<=10 & x>=-10 & y<=10 & y>=-10) {
    return(exp(-x^2/2)*exp(-((1/sin(y))^5-x)^2/2)) 
    } else {return(0)}
}
N=1e5;K=3;
x=y=rep(0,N+1);
u=matrix(runif(2*N,0,1),N,2);
x[1]=0;y[1]=2; 
S=matrix(0,N+1,K)
S[1,]=rep(y[1],K);
for(i in 1:N){
  temp.x=rtnorm(1,x[i],0.5,lower=-10,upper=10)
  if(u[i,1]<sum(unlist(lapply(S[i,],function(a){target(temp.x,a)})))*dtnorm(x[i],temp.x,0.5,lower=-10,upper=10)/sum(unlist(lapply(S[i,],function(a){target(x[i],a)})))/dtnorm(temp.x,x[i],0.5,lower=-10,upper=10)) x[i+1]=temp.x else x[i+1]=x[i]
  id=sample(1:K,1);
  tmp=S[i,];
  tmp[id]=rtnorm(1,S[i,id],0.5,lower=-10,upper=10)
  if(u[i]<=sum(unlist(lapply(tmp,function(a){target(x[i+1],a)})))*dtnorm(S[i,id],tmp[id],0.5,lower=-10,upper=10)/sum(unlist(lapply(S[i,],function(a){target(x[i+1],a)})))/dtnorm(tmp[id],S[i,id],0.5,lower=-10,upper=10)) S[i+1,]=tmp else S[i+1,]=S[i,]
 }
 
endpoint=seq(-10,10,0.1)
hiscount=matrix(0,length(endpoint)-1,K)
for(i in 1:K){
	hiscount[,i]=hist(S[,i],breaks=endpoint)$density
}
count=apply(hiscount,1,mean)
count=K*(count-1/30)
myhist=list(breaks=endpoint, density=count,xname="Y")
class(myhist)="histogram"
plot(myhist,freq=F,ylim=c(-0.02,0.25),main="")
g=function(x){exp(-(1/sin(x))^10/4)/4.488231}
curve(g,-10,10,ylim=c(0,0.25),xlab="y",add=T,lwd=2,n=10000)


## GMSS ##
w=matrix(0,dim(S)[1],dim(S)[2])
for(i in 1:dim(S)[1]){
	for(j in 1:dim(S)[2]){
		w[i,j]=target(x[i],S[i,j])
	}
}
w=w/apply(w,1,sum)
endpoint=seq(-10,10,0.1)
ind=ceiling((S-(-10))/0.1)
temp = sapply(1:(length(endpoint)-1), function(u){sum(w[ind<=u])})
count=temp/(N+1)
count=c(count[1],diff(count))
myhist=list(breaks=endpoint, density=count*10,xname="Y")
class(myhist)="histogram"
plot(myhist,freq=F,ylim=c(0,0.25),main="")
g=function(x){exp(-(1/sin(x))^10/4)/4.488231}
curve(g,-10,10,ylim=c(0,0.2),xlab="y",add=T,lwd=2,n=10000)
