#load the simulated data from the four-component mixture normal 
load("data_fit mixture normal.Rdata")
data

# require package "MASS"
library("MASS")


## Gibbs sampler ##
N=1e5;
sigma=0.4
mu=matrix(0,N+1,3)
mu[1,]=c(3,-4,-3)
for(i in 1:N){
	p=matrix(0,100,3);z=NULL
	for(t in 1:3){
		p[,t]=exp(-(data-mu[i,t])^2/(2*sigma^2))
	}
	for(j in 1:100){
		z[j]=sample(1:3,1,prob=p[j,])
	}
	d.sum=z.n=NULL
	for(t in 1:3){
		id=which(z==t)
		d.sum[t]=sum(data[id])
		z.n[t]=length(id)		
	}
	mu.mean=d.sum/(sigma^2+z.n)
	mu.sigma=sigma^2/(sigma^2+z.n)
	mu[i+1,]=mvrnorm(1,mu=mu.mean,diag(mu.sigma))
}

plot(mu[,1],ylim=c(-5,5),type="n",ylab="")
lines(mu[,1],col="yellow")
lines(mu[,2],col="blue")
lines(mu[,3],col="green")
abline(h=3,lty=2)
abline(h=4,lty=2)
abline(h=-3,lty=2)
abline(h=-4,lty=2)



## R-SMS-CBMC ##
ind_range=function(x){
	ind=ifelse(all(x<6 & x>-6),1,0)
	return(ind)
}
ind_x=function(x,y){
	ind=ifelse(all(x==y),1,0)
	return(ind)
}
target_x=function(x){
	prior=prod(dnorm(x,mean=0,sd=1))
	lik=matrix(0,100,length(x))
	for(i in 1:length(x)){lik[,i]=dnorm(data,x[i],sd=sigma)}
	likelihood=prod(apply(lik,1,sum)/3)
	return(prior*likelihood)
}
target2_s=function(s){
	temp=NULL
	for(i in 1:k){
		temp[i]=target_x(s[,i])*ind_range(s[,-i])
	}
	result=1/k*sum(temp)
	return (result)
}

N=1e5; k=2
sigma=0.4
tao=0.2 #sd for proposal distribution
mu=matrix(0,N+1,3)
mu[1,]=c(3,-4,-3)
s=matrix(rep(mu[1,],k),byrow=F,ncol=k)
u=runif(N,0,1)
for(i in 1:N){
	s.id=sample(1:k,1)
	news=s; news[,s.id]=mvrnorm(1,mu=s[,s.id],diag(tao^2,3))
	if(u[i]<target2_s(news)/target2_s(s)) s=news
	p=NULL
	for(j in 1:k){
		p[j]=target_x(s[,j])*ind_range(s[,-j])
	}
	mu.id=sample(1:k,1,prob=p)
	mu[i+1,]=s[,mu.id]	
}

plot(mu[,1],ylim=c(-5,5),type="n",ylab="")
lines(mu[,1],col="yellow")
lines(mu[,2],col="blue")
lines(mu[,3],col="green")
abline(h=3,lty=2)
abline(h=4,lty=2)
abline(h=-3,lty=2)
abline(h=-4,lty=2)
